.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm			; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

MakeSlow =	0	; code location matters...!??
TestRegs =	1	; test which registers are preserved
TestAdd3 =	0	; test first version, add3$
UseLen =	0

cyctShowSlow =	8	; show the slowest n readings
cyctCutFast =	10

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

      szCatStr2 PROTO :DWORD, :DWORD
      szCatStr3 PROTO :DWORD, :DWORD
      szCatStr4 PROTO :DWORD, :DWORD

    ; ********************************
    ; BASIC string function emulation
    ; ********************************
      addx$ MACRO lpSource,lpAppend
        invoke szCatStr2,tstarg(lpSource),reparg(lpAppend)
        EXITM <eax>
      ENDM

cyct_begin MACRO cyct_lc, cyct_prio	;; both arguments are optional
LOCAL cyct_prioclass
  cyctCutFast = 10
  ifnb <cyct_lc>
	cyctSubCt = cyct_lc/1000 				;; 1000 entries in cyct_table
  else
	cyctSubCt = LOOP_COUNT/1000
  endif
  if cyctSubCt lt 50
  	cyctSubCt = 50
  	;echo increased to 50 (25 seems to be the minimum for reasonable timings)
  endif
  ifnb <cyct_prio>
	cyct_prioclass equ <cyct_prio> 		;; v v default below
  else
	cyct_prioclass equ HIGH_PRIORITY_CLASS
  endif
  ifdef cyctSleepMs
	invoke Sleep, cyctSleepMs
  endif
  ; int 3
  and cyct_counter, 0								;; clear the counter
  .Repeat
	counter_begin cyctSubCt, cyct_prioclass
ENDM
; -------------------------------------------------------------------------	mov eax, len(offset Tst50)	; the code in between the two macros ---------------------
cyct_end MACRO arg
LOCAL tmp$
  counter_end
  	mov edx, cyct_counter
  	mov [cyct_table+4*edx], eax
	inc cyct_counter
  .Until edx>=sizeof cyct_table/4
;  pushad
;  print chr$(13, 10, "Cyct=")
;  print str$(cyct_counter), "/"
;  print str$(sizeof cyct_table/4), 13, 10
;  popad
  tmp$ CATSTR <mov eax, chr$(">, <arg>, <")>
  ;% echo tmp$
  tmp$
  call cyct_endP	;; calculate and show results
ENDM

add3$ MACRO lpDest,args:VARARG
LOCAL flag
  FOR argX, <args>
	ifndef flag
		flag = 1
		invoke szCatStr3, tstarg(lpDest),reparg(argX)
	else
		invoke szCatStr3, 0, reparg(argX)
	endif
  ENDM
  EXITM <eax>
ENDM

add4$ MACRO lpDest,args:VARARG
LOCAL flag
  FOR argX, <args>
	ifndef flag
		flag = 1
		invoke szCatStr4, tstarg(lpDest),reparg(argX)
	else
		invoke szCatStr4, 0, reparg(argX)
	endif
  ENDM
  EXITM <eax>
ENDM

.data?
cyct_counter	dd ?, ?, ?, ?, ?
cyct_table	dd 1000 dup(?)

	dd 10240 dup(?)

      tstbuf 	dd 1024 dup(?)

jjflag	dd ?


    .data
      buffer db "text ",0,"                                                                                     "
      txt1 db "text 1 ",0
      txt2 db "text 2",0
      txt3 db "text 3",0
      txt4 db "text 4",0
      txt5 db "text 5",0
      txt6 db "text 6",0

;      tstbuf db "test ",0,"                                                                                    "
; TstStr	equ <" simulates an average source code line of 54 bytes", 13, 10, 0>
TstStr	equ <13, 10, 0>

      tst1 db "test 1", TstStr
      tst2 db "test 2", TstStr
      tst3 db "test 3", TstStr
      tst4 db "test 4", TstStr
      tst5 db "test 5", TstStr
      tst6 db "test 6", TstStr
dummy	dd 10000 dup("X")


    .code

start:
   
; 

    call main
    print chr$(13, 10, 10)
    inkey
    exit

; 
csize macro algo
LOCAL  tmp$
  tmp$ CATSTR <algo>, <            >	;; 12 blanks
  tmp$ SUBSTR tmp$, 1, 12
  tmp$ CATSTR <print ">, tmp$, < = ">
  tmp$
  mov eax, offset &algo&_END-&algo&
  print str$(eax), 13, 10
ENDM

main proc

    print str$(OFFSET buffer)," original address",13,10,13,10

    invoke szCatStr2,ADDR buffer,ADDR txt1
    print str$(eax)," 1st return address",13,10
    print ADDR buffer,13,10

    invoke szCatStr2,ADDR buffer,ADDR txt2
    print str$(eax)," 2nd return address",13,10
    print ADDR buffer,13, 10, 10, 10

    mov byte ptr tstbuf, 0
    print "test addx$ macro",13,10
    print chr$("print addx$(addx$(addx$(addx$(addx$(addx$(ADDR tstbuf,ADDR tst1),ADDR tst2),ADDR tst3),ADDR tst4),ADDR tst5),ADDR tst6)", 13, 10)
    print addx$(addx$(addx$(addx$(addx$(addx$(ADDR tstbuf,ADDR tst1),ADDR tst2),ADDR tst3),ADDR tst4),ADDR tst5),ADDR tst6)

    if TestAdd3
    mov byte ptr tstbuf, 0
    print chr$(13, 10, "test add3$ macro, old syntax",13,10)
    print chr$("print add3$(add3$(add3$(add3$(add3$(add3$(ADDR tstbuf,ADDR tst1),ADDR tst2),ADDR tst3),ADDR tst4),ADDR tst5),ADDR tst6)", 13, 10)
    print add3$(add3$(add3$(add3$(add3$(add3$(ADDR tstbuf,ADDR tst1),ADDR tst2),ADDR tst3),ADDR tst4),ADDR tst5),ADDR tst6)

    mov byte ptr tstbuf, 0

    print chr$(13, 10, "test add3$ macro, new syntax",13,10)
    print chr$("print add3$(ADDR tstbuf,ADDR tst1,ADDR tst2,ADDR tst3,ADDR tst4,ADDR tst5,ADDR tst6)", 13, 10)
    print add3$(ADDR tstbuf,ADDR tst1,ADDR tst2,ADDR tst3,ADDR tst4,ADDR tst5,ADDR tst6)
    endif

    mov byte ptr tstbuf, 0
    print chr$(13, 10, "test add4$ macro, old syntax",13,10)
    print chr$("print add4$(add4$(add4$(add4$(add4$(add4$(ADDR tstbuf,ADDR tst1),ADDR tst2),ADDR tst3),ADDR tst4),ADDR tst5),ADDR tst6)", 13, 10)
    print add4$(add4$(add4$(add4$(add4$(add4$(ADDR tstbuf,ADDR tst1),ADDR tst2),ADDR tst3),ADDR tst4),ADDR tst5),ADDR tst6)

    mov byte ptr tstbuf, 0
    inc jjflag
    print chr$(13, 10, "test add4$ macro, new syntax",13,10)
    print chr$("print add4$(ADDR tstbuf,ADDR tst1,ADDR tst2,ADDR tst3,ADDR tst4,ADDR tst5,ADDR tst6)", 13, 10)
    print add4$(ADDR tstbuf,ADDR tst1,ADDR tst2,ADDR tst3,ADDR tst4,ADDR tst5,ADDR tst6)

    if TestRegs
	print chr$(13, 10, "Regs preserved:")
	print chr$(13, 10, "addx$/szCatStr2: ")
	push 12345h
	pop ecx
	mov edx, ecx
	mov byte ptr tstbuf, 0
	mov eax, addx$(addx$(addx$(addx$(addx$(addx$(ADDR tstbuf,ADDR tst1),ADDR tst2),ADDR tst3),ADDR tst4),ADDR tst5),ADDR tst6)
	.if ecx==12345h
		pushad
		print "ecx "
		popad
	.endif
	.if edx==12345h
		pushad
		print "edx"
		popad
	.endif

	if 0 ; TestAdd3
	print chr$(13, 10, "add3$/szCatStr3: ")
	push 12345h
	pop ecx
	mov edx, ecx
	mov byte ptr tstbuf, 0
	mov eax, add3$(add3$(add3$(add3$(add3$(add3$(ADDR tstbuf,ADDR tst1),ADDR tst2),ADDR tst3),ADDR tst4),ADDR tst5),ADDR tst6)
	.if ecx==12345h
		pushad
		print "ecx "
		popad
	.endif
	.if edx==12345h
		pushad
		print "edx"
		popad
	.endif
	endif

	print chr$(13, 10, "add4$/szCatStr4: ")
	push 12345h
	pop ecx
	mov edx, ecx
	mov byte ptr tstbuf, 0
	mov eax, add4$(add4$(add4$(add4$(add4$(add4$(ADDR tstbuf,ADDR tst1),ADDR tst2),ADDR tst3),ADDR tst4),ADDR tst5),ADDR tst6)
	.if ecx==12345h
		pushad
		print "ecx "
		popad
	.endif
	.if edx==12345h
		pushad
		print "edx"
		popad
	.endif
    endif

	LOOP_COUNT = 200000
	print chr$(13, 10, 10, "timings:", 13, 10)

	invoke Sleep, 200
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov byte ptr tstbuf, 0
		mov eax, addx$(addx$(addx$(addx$(addx$(addx$(ADDR tstbuf,ADDR tst1),ADDR tst2),ADDR tst3),ADDR tst4),ADDR tst5),ADDR tst6)
	counter_end
	print str$(eax), " cycles for addx$", 13, 10

    if TestAdd3
	invoke Sleep, 200
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov byte ptr tstbuf, 0
		mov eax, add3$(add3$(add3$(add3$(add3$(add3$(ADDR tstbuf,ADDR tst1),ADDR tst2),ADDR tst3),ADDR tst4),ADDR tst5),ADDR tst6)
	counter_end
	print str$(eax), " cycles for add3$, old syntax", 13, 10
    endif

	invoke Sleep, 200
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov byte ptr tstbuf, 0
		mov eax, add4$(add4$(add4$(add4$(add4$(add4$(ADDR tstbuf,ADDR tst1),ADDR tst2),ADDR tst3),ADDR tst4),ADDR tst5),ADDR tst6)
	counter_end
	print str$(eax), " cycles for add4$, old syntax", 13, 10

    if TestAdd3
	invoke Sleep, 200
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov byte ptr tstbuf, 0
		mov eax, add3$(ADDR tstbuf,ADDR tst1,ADDR tst2,ADDR tst3,ADDR tst4,ADDR tst5,ADDR tst6)
	counter_end

	print str$(eax), " cycles for add3$, short syntax", 13, 10
    endif



	invoke Sleep, 2
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov byte ptr tstbuf, 0
		mov eax, add4$(ADDR tstbuf,ADDR tst1,ADDR tst2,ADDR tst3,ADDR tst4,ADDR tst5,ADDR tst6)
	counter_end

	print str$(eax), " cycles for add4$, short syntax", 13, 10

	cyct_begin
;		REPEAT 10
;		push eax
;		pop eax
;		ENDM
		mov byte ptr tstbuf, 0
		mov eax, add4$(ADDR tstbuf,ADDR tst1,ADDR tst2,ADDR tst3,ADDR tst4,ADDR tst5,ADDR tst6)
	cyct_end MyTest
	;int 3
	if MakeSlow
		print chr$(10, "Code sizes:", 13, 10)
;		341 cycles for addx$
;		584 cycles for add4$, old syntax
;		324 cycles for add4$, short syntax
	else
		print chr$(10, 10, "Code sizes:", 13, 10)
;		341 cycles for addx$
;		531 cycles for add4$, old syntax
;		192 cycles for add4$, short syntax
	endif
	csize szCatStr2
    if TestAdd3
	csize szCatStr3
    endif
	csize szCatStr4
    ret

main endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16
szCatStr2 proc lpszSource:DWORD, lpszAdd:DWORD
    invoke StrLen,[esp+4]           ; get source length
    mov edx, [esp+4]                ; load source address
    mov ecx, [esp+8]                ; load append string address
    add edx, eax                    ; set write starting position

    push edi
    or edi, -1

  @@:

  REPEAT 3

    add edi, 1
    movzx eax, BYTE PTR [ecx+edi]   ; read byte from append string and zero extend it
    mov [edx+edi], al               ; write append string to end of source
    add eax, eax
    jz @F

  ENDM

    add edi, 1
    movzx eax, BYTE PTR [ecx+edi]   ; read byte from append string and zero extend it
    mov [edx+edi], al               ; write append string to end of source
    add eax, eax
    jnz @B

  @@:

    pop edi

    mov eax, [esp+4]                ; return start address of source for macro

    ret 8

szCatStr2 endp
szCatStr2_END:

align 16
szCatStr3 proc lpszDest:DWORD, lpszAdd:DWORD
.data
  szCatEnd	dd ?
  szCatStart	dd ?
.code
	push edi
	push esi
	mov edi, [esp+8+4]			; load destination address
	.if sdword ptr edi>0
		mov szCatStart, edi		; pointer to be returned in eax
		if UseLen
	invoke StrLen, edi           ; get source length
			add edi, eax	;len(edi)		; trashes ecx, edx??
		else
;		.if jjflag
;			and jjflag, 0
			;int 3
;			mov eax, eax
;		.endif

@@:		REPEAT 2
		  movzx eax, byte ptr [edi]
		  test eax, eax
		  je @F
		  inc edi
		ENDM
		jmp @B
@@:
		;int 3
		mov ebx, ebx
		
		; dec edi
		endif
	.else
		mov edi, szCatEnd
	.endif
	mov esi, [esp+8+8]			; load append string address

@@:	REPEAT 1
	  movzx eax, byte ptr [esi]		; read byte from append string and zero extend it
	  mov [edi], al					; write append string to end of source
	  add eax, eax
	  je @F
	  add esi, 1
	  add edi, 1
	ENDM
	movzx eax, byte ptr [esi]		; read byte from append string and zero extend it
	mov [edi], al					; write append string to end of source
	add eax, eax
	je @F
	add esi, 1
	add edi, 1
	jmp @B

@@:
;	dec edi
	mov szCatEnd, edi
	mov eax, szCatStart			; return start address of source for macro
	pop esi
	pop edi
	ret 2*4
szCatStr3 endp
szCatStr3_END:

align 16	; MakeSlow?
;cpuid
;rdtsc
;INT 3
;retn
szCatStr4 proc lpszDest:DWORD, lpszAdd:DWORD
.data
  szCat4End	dd ?
  szCat4Start	dd ?
.code
	;int 3
	push edi
	push esi
	mov edi, [esp+8+4]						; load destination address: if 0, append to szCat4End
	test edi, edi
	.if !Zero?
		mov szCat4Start, edi					; pointer to be returned in eax
		if 0 ; UseLen			 				; should be faster but the short macro syntax doesn't like the overhead
			invoke StrLen, edi				; get source length
			add edi, eax	;len(edi)		; trashes ecx, edx??
		else

@@:		REPEAT 1		; Rep>1 unrolling has no measurable positive effect (on P4 and Celeron M)
		  movzx eax, byte ptr [edi]
		  inc edi
		  add eax, eax
		  je @F
		ENDM

		movzx eax, byte ptr [edi]
		inc edi
		add eax, eax
		jne @B
@@:
		endif
	.else
		mov edi, szCat4End		; dest 0: append to szCat4End
	.endif
	dec edi							; sub edi, 1 a cycle faster on P4 only
	mov esi, [esp+8+8]			; load append string address
	push ecx
	xor ecx, ecx

	OldP4 = 0									; P4 prefers add ecx, 1 and add eax, eax

@@:	REPEAT 1									; Rep>1 has no measurable positive effect
		movzx eax, byte ptr [esi+ecx]	; read byte from append string and zero extend it
		mov [edi+ecx], al						; write append string to end of source
		if OldP4
			add ecx, 1
			add eax, eax
		else
			inc ecx
			test eax, eax
		endif
		jz @F
	ENDM
	movzx eax, byte ptr [esi+ecx]			; read byte from append string and zero extend it
	mov [edi+ecx], al							; write append string to end of source
	if OldP4
		add ecx, 1
		add eax, eax
	else
		inc ecx
		test eax, eax
	endif
	jnz @B

@@:	add edi, ecx
	pop ecx
	mov szCat4End, edi			; prepare for next call
	mov eax, szCat4Start			; return start address of source for macro
	pop esi
	pop edi
	ret 2*4
szCatStr4 endp
szCatStr4_END:

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

cyct_endP proc
  push ebp
  push esi
  push ebx
  push eax
  inc edx
  invoke CombSortA, offset cyct_table, edx
  xor ebx, ebx
  print chr$(13, 10)
  if cyctShowSlow
	print chr$(10)
	.Repeat
  		print str$(ebx), ":"
		mov eax, [cyct_table+4*ebx]
		print str$(eax), " "
	  	inc ebx
	.Until ebx>cyctCutFast
	print chr$(13, 10, 10, "...", 13, 10, 10)
	mov ebx, cyct_counter
	sub ebx, cyctShowSlow
	.Repeat
  		print str$(ebx), ":"
		mov eax, [cyct_table+4*ebx]
		print str$(eax), " "
  		inc ebx
	.Until ebx>=cyct_counter
  endif
  pop ebp	; pushed as eax
  .if byte ptr [ebp]!="#"
	print chr$(13, 10)
	print ebp
	print chr$(13, 10, "average with cutoff", 9)
  .endif
  push cyctCutFast
  pop ebx
  mov eax, [cyct_table+4*cyctCutFast]		;; determine the cutoff value
  mov esi, eax			; eax is one of the lowest timings
  shr esi, 2			; /4
  inc esi
  add esi, eax			; esi = eax * 1.25 + 1
  xor eax, eax
  .Repeat
	mov ecx, [cyct_table+4*ebx]
	inc ebx
	.Break .if ecx>esi
	add eax, ecx
  .Until ebx>cyct_counter
  sub ebx, cyctCutFast+2
  cdq
  div ebx
  push eax
  print str$(eax)
  .if byte ptr [ebp]!="#"
	.if ebx<=sizeof cyct_table/4-cyctCutFast-1
		print chr$(32, 9, "cutoff at n=")
		add ebx, cyctCutFast+1
		print str$(ebx), " for ct", 62, "="	; >=
		print str$(esi), " cycles"
	.else
  		print chr$(32, 9, "no cutoff")
	.endif
	print chr$(13, 10, "average w/o cutoff ", 9)
	; print str$(cyct_counter), 9
  .endif
  xor eax, eax
  xor ebx, ebx
  mov edx, cyct_counter
  ; int 3
  .Repeat
	add eax, [cyct_table+4*ebx]
	inc ebx
  .Until ebx>edx
  dec ebx
  cdq
  div ebx
  mov ebx, eax
  .if byte ptr [ebp]!="#"
	print str$(eax), 13, 10, "difference raw-cutoff:", 9
	sub ebx, [esp]
	print str$(ebx)
  .endif
  pop eax
  pop ebx
  pop esi
  pop ebp
  ret
cyct_endP endp

; 

end start
OPT_WAIT	0
OPT_Tmp2Asm	1

MakeSlow = 1

341 cycles for addx$
584 cycles for add4$, old syntax
324 cycles for add4$, short syntax

0040193C               ?  5E                         pop esi
0040193D               ?  5F                         pop edi
0040193E               ?  C2 0800                    retn 8
00401941              .  8DA424 00000000             lea esp, [local.0]
00401948              . 8DA424 00000000             lea esp, [local.1]
0040194F              ?  90                          nop
00401950              >  CC                          int3		<<<<<<<<<<<<<<<<<< algo start
00401951              ?  57                          push edi
00401952              ?  56                          push esi

*** print chr$(10, "Code sizes:", 13, 10)
00401805              .  40                          inc eax                                                                  ; Arg1 => ASCII 0A,"Code sizes"
00401806              ?  00E8                        add al, ch                                                               ;
00401808              ?  90                          nop                                                                      ;
00401809              ?  0100                        add dword ptr [eax], eax                                                 ;
0040180B              ?  00CC                        add ah, cl
0040180D              ?  68 59C04000                 push offset AddStrB.0040C059                                             ; ASCII 0A,"Code sizes"
00401812              ?  E8 89030000                 call 00401BA0                                                            ;
00401817              ?  68 68C04000                 push offset AddStrB.0040C068                                             ; ASCII "szCatStr2    = "
0040181C              ?  E8 7F030000                 call 00401BA0

MakeSlow = 0

341 cycles for addx$
531 cycles for add4$, old syntax
192 cycles for add4$, short syntax

0040193C               ?  5E                         pop esi
0040193D               ?  5F                         pop edi
0040193E               ?  C2 0800                    retn 8
00401941              .  8DA424 00000000             lea esp, [local.0]
00401948              . 8DA424 00000000             lea esp, [local.1]
0040194F              ?  90                          nop
00401950              >  CC                          int3		<<<<<<<<<<<<<<<<<< algo start
00401951              ?  57                          push edi
00401952              ?  56                          push esi
00401953              .  8B7C24 0C                   mov edi, dword ptr [arg1]

*** print chr$(10, 10, "Code sizes:", 13, 10)
00401805              .  40                          inc eax                                                                  ; Arg1 => ASCII LF,LF,"Code sizes:",CR,LF
00401806              ?  00E8                        add al, ch                                                               ;
00401808              ?  90                          nop                                                                      ;
00401809              ?  0100                        add dword ptr [eax], eax                                                 ;
0040180B              ?  00CC                        add ah, cl
0040180D              ?  68 59C04000                 push offset AddStrB.0040C059                                             ; ASCII LF,LF,"Code sizes:",CR,LF
00401812              ?  E8 89030000                 call 00401BA0                                                            ;
00401817              ?  68 69C04000                 push offset AddStrB.0040C069                                             ; ASCII "szCatStr2    = "
0040181C              ?  E8 7F030000                 call 00401BA0
